-- Based on the game's "beamNavigator.lua" of BeamNG's navigator

local M = {}

local htmlTexture = require("htmlTexture")

local function getPhotos()
	local photos = nil
	if FS:directoryExists("gps_pictures") then
		for i, pattern in pairs({"*.jpg", "*.png"}) do
			for i, photo in pairs(FS:findFiles("gps_pictures", pattern, 5, false, false)) do
				photos = photos or {}
				table.insert(photos, photo);
			end
		end
	end
	
	if FS:directoryExists("vehicles/common/gps_pictures_pack") then
		for i, pattern in pairs({"*.jpg", "*.png"}) do
			for i, photo in pairs(FS:findFiles("vehicles/common/gps_pictures_pack", pattern, 10, false, true)) do
				photos = photos or {}
				table.insert(photos, photo);
			end
		end
	end
	
	return photos
end

local function init(jbeamData)
	local screenMaterialName = jbeamData.screenMaterialName or "@screen_gps"
	local htmlFilePath = "local://local/vehicles/common/gpsphotoframe.html"
	
	local data = {
		duration = jbeamData.duration,
		photos = getPhotos(),
		includeDefault = jbeamData.default > 0.5
	}
	
	htmlTexture.create(screenMaterialName, htmlFilePath, 256, 128, 3, "automatic")
	htmlTexture.call(screenMaterialName, "initialize", data);
end

M.init = init

return M
